/***************************************************************************
                          check_headers.c  -  description
                             -------------------
    begin                : Sat Jul 3 2004
    copyright            : (C) 2004 by rodney mulraney
    email                : rmulraney@compuserve.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 #include <stdio.h>
#include <stdlib.h>
#include "stegnate.h"

extern unsigned short bit_res ;
extern FILE * where ;

int check_wave_header(struct wav_h * hd){
	if(hd->riff_magic[0] != 'R' || hd->riff_magic[1] != 'I' || hd->riff_magic[2] !='F' || hd->riff_magic[3] != 'F'){
		printf("Magic File Identifier : !Error Not a RIFF\n") ;
		return 1 ;
	}
	printf("Identified RIFF header\nPackage Length : \t\t%d\n",hd->package_len) ;
	if(hd->type[0] != 'W' || hd->type[1] != 'A' || hd->type[2] != 'V' || hd->type[3] != 'E'){
		printf("RIFF is not of WAVE type\n") ;
		return 1 ;
	}
	if(hd->chunk_fmt[0] != 'f' || hd->chunk_fmt[1] != 'm' || hd->chunk_fmt[2] != 't' || hd->chunk_fmt[3] != ' '){
		printf("Could'nt sync format chunk!\n\n") ;
		return 1 ;
	}
	printf("Got 'fmt' chunk !\nLength of Format Chunk : \t\t%d\n",hd->fmt_len) ;
	if(hd->spec != 1){
		printf("\nCan't handle this wave file, it may be compressed :(\n\n") ;
		return 1 ;
	}
	printf("Channels              : \t\t%d\n",hd->channels) ;
	printf("Sample Rate         : \t\t%d\n",hd->sample_rate) ;
	printf("Bytes per Second  : \t\t%d\n",hd->bytes_per_sec) ;
	printf("Bytes per Sample  : \t\t%d\n",hd->bytes_per_sample) ;
	printf("Bits per Sample     : \t\t%d\n",hd->bits_per_sample) ;
	if(hd->bits_per_sample != 8 && hd->bits_per_sample != 16){
		printf("This Wave File is not sampled at 8 or 16 bits :(\n") ;
		return 1 ;
	}
	bit_res = (hd->bits_per_sample == 8) ? 0 : 1 ;
	if(hd->chunk_data[0] != 'd' || hd->chunk_data[1] != 'a' || hd->chunk_data[2] != 't' || hd->chunk_data[3] != 'a'){
		printf("Unable to Synchronise with the 'data' chunk.\n\n") ;
		return 1 ;
	}
	printf("Got 'data' chunk\nActuall Length of Wave data : \t%d bytes.\n",hd->data_len) ;
	return 0 ;
}

int check_bmp_header(struct bmp_h * head){
	//if(head->type != 19778){
		//printf("This File Does not have a Valid BMP Magic Number\n") ;
		//return 1;
	//}
	printf("Found BMP Magic !\nFile Size = \t\t%d Bytes\n", head->size) ;
	printf("Image Size = \t\t%d Bytes\n", head->imagesize) ;
	printf("Image Dimesions :\n") ;
	printf("\t Width = \t\t%d Pixels\n", head->width) ;
	printf("\t Height = \t\t%d Pixels\n", head->height) ;
	printf("Bits Per Pixel = \t\t%d Bits\n", head->bits) ;
	printf("Number of Colours = \t\t%d\n", head->ncolours) ;
	printf("Compression Type = \t\t%d\n", head->compression) ;
	if(head->compression != 0){
		printf("This BMP is Compressed current implementation cannot handle this :(\n") ;
		return 1 ;
	}
	if(head->bits != 24){
		printf("This BMP is NOT in 24 bit mode, Skipping file...\n") ;
		return 1 ;
	}

	if(fseek(where, head->offset, SEEK_SET) != 0){
		printf("ERROR : Could not move file pointer to Picture Data :(\n") ;
		return 1 ;
	}
	return 0 ;
}

