
/***************************************************************************
                          stegnate.h  -  description
                             -------------------
    begin                : Sat Jul 3 2004
    copyright            : (C) 2004 by rodney mulraney
    email                : rmulraney@compuserve.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef STEG_H
#define STEG_H
#define HIDE 1
#define EXTRACT 0

#ifdef WITH_GTK
/*>>>>>>>>>>>>>>>>>>>>>Change this next define if compiling Gtk version, and you want a different home dir*/
#define HOME_DIR "~"
#endif

struct wav_h {
	char riff_magic[4] ; // "RIFF"
	unsigned int package_len ; // total length of package to follow
	char type[4] ; // "WAVE" , here ends actual header
	char chunk_fmt[4] ; // ASSUMES fmt chunk is straight after header, which should be "fmt "
	unsigned int fmt_len ; //length of this format chunk, after this
	unsigned short spec ; // should be 1 or maybe compressed.. or char[0] should == 1 , char[1] == 0
	unsigned short channels ; // 1 == mono, 2 == stereo ie char[0]
	unsigned int sample_rate ;
	unsigned int bytes_per_sec ;
	unsigned short bytes_per_sample ;
	unsigned short bits_per_sample ;
	char chunk_data[4] ; // ASSUMES data chunk straight after format chunk
	unsigned int data_len ; // length of actual wav data  ... THESE LAST two data fields only added to get file pointer to first bye of actual data
} ;

struct bmp_h {
	//unsigned short type ;                 /* Magic identifier            */
	unsigned int size ;                       /* File size in bytes          */
	unsigned short reserved1 ;
	unsigned short reserved2 ;
	unsigned int offset;                     /* Offset to image data, bytes */
	/*Information segment, not strictly part of the header*/
	unsigned int hsize;               /* Header size in bytes      */
	int width,height;                /* Width and height of image */
	unsigned short planes;       /* Number of colour planes   */
	unsigned short bits;         /* Bits per pixel            */
	unsigned int compression;        /* Compression type          */
	unsigned int imagesize;          /* Image size in bytes       */
	int xresolution,yresolution;     /* Pixels per meter          */
	unsigned int ncolours;           /* Number of colours         */
	unsigned int importantcolours;   /* Important colours         */
} ;


int check_wave_header(struct wav_h *) ;
int check_bmp_header(struct bmp_h *) ;
int open_where(char *) ;

void next_where_data(void) ;
#endif
